package com.gfeng.daydaycook.activity

import android.annotation.SuppressLint
import android.graphics.Bitmap
import android.os.Bundle
import android.text.TextUtils
import android.view.Menu
import android.view.MenuItem
import cn.sharesdk.framework.Platform
import cn.sharesdk.framework.PlatformActionListener
import com.gfeng.daydaycook.R
import com.gfeng.daydaycook.ui.CustomWebview
import com.gfeng.daydaycook.util.LogUtils
import com.tencent.smtt.sdk.WebChromeClient
import com.tencent.smtt.sdk.WebSettings
import com.tencent.smtt.sdk.WebView
import com.tencent.smtt.sdk.WebViewClient
import kotlinx.android.synthetic.main.activity_pgc_recuit_h5.*
import kotlinx.android.synthetic.main.top_layout.*

@Suppress("DEPRECATION")
class PGCRecuitH5Activity : BaseActivity(), PlatformActionListener {

    companion object {
        private val TAG = PGCRecuitH5Activity::class.java.simpleName
        private const val toast_rerfresh_type = 100

        const val PGC_URL = "PGC_RECUIT_URL"
        const val TITLE = "TITLE"
        const val SHARE_IMG = "SHARE_IMG"
    }

    private var url: String? = null
    private var title: String? = null
    private var settings: WebSettings? = null
    private var mWebView: CustomWebview? = null
    private var failUrl = ""
    private val errorUrl = "file:///android_asset/error.html"
    private var shareImg = ""
    private var shareUrl = ""

    override fun aidHandleMessage(what: Int, obj: Any?) {

    }


    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_pgc_recuit_h5)
        initUi()
    }

    private fun initUi() {
        mTitle.text = "签到奖励"
        url = intent.getStringExtra(PGC_URL)
        title = intent.getStringExtra(TITLE)
        shareImg = intent.getStringExtra(SHARE_IMG)
        shareUrl = "$url&isShare=1"

        if (TextUtils.isEmpty(url)) {
            finish()
            return
        }

        backButton.setOnClickListener { finish() }


        if (!TextUtils.isEmpty(title)) {
            mTitle.text = title
        }

        initWebView()
        initData()

    }

    @SuppressLint("AddJavascriptInterface", "SetJavaScriptEnabled")
    private fun initWebView() {
        mWebView = CustomWebview(applicationContext)
        settings = mWebView?.settings
        settings?.javaScriptEnabled = true
        settings?.useWideViewPort = true
        settings?.loadWithOverviewMode = true
        settings?.layoutAlgorithm = WebSettings.LayoutAlgorithm.SINGLE_COLUMN
        settings?.cacheMode = WebSettings.LOAD_NO_CACHE
        mWebView?.webViewClient = webViewClient
        mWebView?.webChromeClient = webChromeClient
        webviewLayout.removeAllViews()
        webviewLayout.addView(mWebView)
        mWebView?.isScrollContainer = false
    }


    private fun initData() {
        mWebView?.loadUrl(url)
        showProgressDialog()
    }


    override fun onComplete(p0: Platform?, p1: Int, p2: HashMap<String, Any>?) {
        if (p1 == 9) {
            aidsendMessage(toast_rerfresh_type, getString(R.string.details_share_success))
        }
    }

    override fun onCancel(p0: Platform?, p1: Int) {}

    override fun onError(p0: Platform?, p1: Int, p2: Throwable?) {
        LogUtils.info("onError===>$p0===$p1")
        LogUtils.e(TAG, p2)
        aidsendMessage(toast_rerfresh_type, getString(R.string.details_share_fail))
    }


    private var webViewClient: WebViewClient = object : WebViewClient() {
        override fun shouldOverrideUrlLoading(view: WebView, url: String): Boolean {
            showProgressDialog()
            view.loadUrl(url)
            return super.shouldOverrideUrlLoading(view, url)
        }

        override fun onPageStarted(view: WebView, url: String?, favicon: Bitmap?) {
            super.onPageStarted(view, url, favicon)
            LogUtils.e(TAG, url)
        }

        override fun onPageFinished(view: WebView, url: String?) {
            super.onPageFinished(view, url)
            hideProgressDialog()

        }

        override fun onReceivedError(view: WebView, errorCode: Int, description: String, failingUrl: String) {
            super.onReceivedError(view, errorCode, description, failingUrl)
            LogUtils.info("failingUrl==>$failingUrl")
            failUrl = failingUrl
            view.loadUrl(errorUrl)
        }
    }

    private var webChromeClient: WebChromeClient = object : WebChromeClient() {
        override fun onProgressChanged(view: WebView, newProgress: Int) {
            super.onProgressChanged(view, newProgress)
            if (newProgress == 100) {
                hideProgressDialog()
            }
        }
    }


    override fun onCreateOptionsMenu(menu: Menu): Boolean {
        menuInflater.inflate(R.menu.lesson_detail_menu, menu)
        return true
    }

    override fun onOptionsItemSelected(item: MenuItem): Boolean {
        aidsendMessage(item.itemId, item)
        return true
    }
}
