package com.gfeng.daydaycook.adapter

import android.text.TextUtils
import android.widget.ImageView
import android.widget.TextView
import com.chad.library.adapter.base.BaseQuickAdapter
import com.chad.library.adapter.base.BaseViewHolder
import com.gfeng.daydaycook.R
import com.gfeng.daydaycook.comm.Global
import com.gfeng.daydaycook.model.FavoriteModel
import com.gfeng.daydaycook.model.SearchModel
import com.gfeng.daydaycook.ui.likebutton.LikeButton
import com.gfeng.daydaycook.util.GlideUtils
import com.gfeng.daydaycook.util.NumFormatUtil
import net.lucode.hackware.magicindicator.buildins.UIUtil

/**
 * Life Is Better With DayDayCook
 * author: l
 * created on: 2019/4/26
 * description:
 */
class RecipeCollectionAdapter(layoutResId: Int) : BaseQuickAdapter<FavoriteModel, BaseViewHolder>(layoutResId) {
    override fun convert(helper: BaseViewHolder?, model: FavoriteModel?) {
        val item_bg = helper?.getView<ImageView>(R.id.item_bg)
        val description = helper?.getView<TextView>(R.id.description)
        val title = helper?.getView<TextView>(R.id.title)
        val look = helper?.getView<TextView>(R.id.look)
        val like = helper?.getView<LikeButton>(R.id.like)
        when (model?.type) {
            "1" -> {
                if (!TextUtils.isEmpty(model?.recipe?.imageUrlFlow)) {
                    GlideUtils.load(model?.recipe?.imageUrlFlow, item_bg)
                } else {
                    GlideUtils.load(model?.recipe?.imageUrl, item_bg)
                }
                val localLayoutParams = item_bg?.layoutParams
                localLayoutParams?.height = (Global.mScreenWidth - 3 * UIUtil.dip2px(mContext, 14.0)) / 2
                item_bg?.layoutParams = localLayoutParams

                title?.text = model?.recipe?.title ?: ""
                description?.text = model?.recipe?.description ?: ""
                look?.text = NumFormatUtil.likeNumFormat(model?.recipe?.clickCount?:0)
                like?.setLiked(model?.recipe?.favorite ?: false)
            }
            "2" -> {
                if (model?.video!=null&&!TextUtils.isEmpty(model?.video?.indexUrl)) {
                    GlideUtils.load(model?.video?.indexUrl, item_bg)
                } else {
                    GlideUtils.load("", item_bg)
                }
                val localLayoutParams = item_bg?.layoutParams
                localLayoutParams?.height = (Global.mScreenWidth - 3 * UIUtil.dip2px(mContext, 14.0)) / 2
                item_bg?.layoutParams = localLayoutParams

                title?.text = model?.video?.title ?: ""
                description?.text = model?.video?.description ?: ""
                look?.text = NumFormatUtil.likeNumFormat(model?.video?.clickCount?:0)
                like?.setLiked(true)
            }
        }
        helper?.addOnClickListener(R.id.like)
    }
}