package com.gfeng.daydaycook.fragment

import android.annotation.SuppressLint
import android.os.Bundle
import android.view.View
import com.gfeng.daydaycook.R
import com.gfeng.daydaycook.activity.BaseActivity
import com.gfeng.daydaycook.activity.ShopWebActivity
import com.gfeng.daydaycook.comm.Comm
import com.gfeng.daydaycook.comm.Global
import com.gfeng.daydaycook.webview.OnJSWebViewLoadListener
import kotlinx.android.synthetic.main.fragment_shop_web.*
import kotlinx.android.synthetic.main.top_layout.*


@Suppress("DEPRECATION")
/**
 * Created by HuangQiang on 18/6/13.
 */

class ShopWebFragment : BaseFragment() {
    var TAG = "ShopWebFragment"
    var baseActivity: BaseActivity? = null


    override fun aidHandleMessage(what: Int, obj: Any?) {
        if (what == Comm.reloadData) {
            no_internet.visibility = View.GONE
            baseActivity?.showProgressDialog(false)
            webView.reload()
        }
    }

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        baseActivity = activity as BaseActivity
    }

    override fun getFragmentViewLayout(): Int {
        return R.layout.fragment_shop_web
    }

    @SuppressLint("AddJavascriptInterface")
    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)
        Global.mAppMgr.setActivityDataRefreshListener(this, Comm.ShopWebFragment_refresh_type)

        backButton.visibility = View.GONE
        mTitle.text = getString(R.string.text_menu_shop)
        webView.loadUrl(Global.webHost + Comm.shop)

        shareButton.visibility = View.VISIBLE
        shareButton.setImageResource(R.drawable.title_cart)
        shareButton.setOnClickListener {
            ShopWebActivity.goToPage(activity!!, "购物车", Global.webHost + Comm.shop_cart)
        }

        baseActivity?.showProgressDialog(false)
        refreshlayout.setOnRefreshListener {
            refreshView()
        }
        webView.setOnJSWebViewLoadListener(object : OnJSWebViewLoadListener {
            override fun loadFail() {
                no_internet.visibility = View.VISIBLE
                baseActivity?.hideProgressDialog()
            }

            override fun onReceivedTitle(title: String?) {
            }

            override fun onPageStart(url: String?) {
            }

            override fun onPageFinish(url: String?) {
                refreshlayout.finishRefresh()
                baseActivity?.hideProgressDialog()
            }
        })
    }

    override fun initImmersionBar() {
        super.initImmersionBar()
        mImmersionBar.titleBarMarginTop(topLayout).init()
    }

    override fun onResume() {
        super.onResume()
        if (Global.navigateBackRefresh) {
            refreshView()
            Global.navigateBackRefresh = false
        }
    }

    private fun refreshView() {
        webView.reload()
        baseActivity?.showProgressDialog(false)
    }

    override fun onDestroyView() {
        super.onDestroyView()

        Global.mAppMgr.setActivityDataRefreshListener(null, Comm.ShopWebFragment_refresh_type)
    }
}
