package com.gfeng.daydaycook.search.adapter

import android.support.v4.content.ContextCompat
import android.text.TextUtils
import android.view.View
import android.widget.ImageView
import android.widget.TextView
import com.chad.library.adapter.base.BaseQuickAdapter
import com.chad.library.adapter.base.BaseViewHolder
import com.gfeng.daydaycook.R
import com.gfeng.daydaycook.comm.Global
import com.gfeng.daydaycook.model.SearchAllModel
import com.gfeng.daydaycook.model.SearchModel
import com.gfeng.daydaycook.ui.likebutton.LikeButton
import com.gfeng.daydaycook.util.GlideUtils
import com.gfeng.daydaycook.util.NumFormatUtil
import com.gfeng.daydaycook.util.TypefaceUtil
import net.lucode.hackware.magicindicator.buildins.UIUtil

/**
 * Life Is Better With DayDayCook
 * author: HuangQiang
 * created on: 2019/4/16 17:28.
 * description:
 */
class SearchRecipeResultAdapter(layoutResId: Int) : BaseQuickAdapter<SearchAllModel, BaseViewHolder>(layoutResId) {
    override fun convert(helper: BaseViewHolder?, model: SearchAllModel?) {
        val view_type0 = helper?.getView<View>(R.id.view_type0)
        val view_type2 = helper?.getView<View>(R.id.view_type2)
        val title2 = helper?.getView<TextView>(R.id.title2)
        val iv_1 = helper?.getView<ImageView>(R.id.iv_1)
        val iv_2 = helper?.getView<ImageView>(R.id.iv_2)
        val iv_3 = helper?.getView<ImageView>(R.id.iv_3)

        val item_bg = helper?.getView<ImageView>(R.id.item_bg)
        val title = helper?.getView<TextView>(R.id.title)
        val tv_make_time = helper?.getView<TextView>(R.id.tv_make_time)
        val like = helper?.getView<LikeButton>(R.id.like)
        val tv_like_count = helper?.getView<TextView>(R.id.tv_like_count)

        when (model?.type){
            0 -> {
                view_type0?.visibility = View.VISIBLE
                view_type2?.visibility = View.GONE

                if (!TextUtils.isEmpty(model?.searchRecipeModel?.imageUrlFlow)) {
                    GlideUtils.load(model?.searchRecipeModel?.imageUrlFlow, item_bg)
                } else {
                    GlideUtils.load(model?.searchRecipeModel?.imageUrl, item_bg)
                }
                val localLayoutParams = item_bg?.layoutParams
                localLayoutParams?.height = (Global.mScreenWidth - 3 * UIUtil.dip2px(mContext, 14.0)) / 2
                item_bg?.layoutParams = localLayoutParams

                title?.text = model?.searchRecipeModel?.title ?: ""
                like?.setLiked(model?.searchRecipeModel?.favorite ?: false)
                tv_make_time?.text = if (model?.searchRecipeModel?.makeTime.isNullOrEmpty()) "" else "时长：" + model?.searchRecipeModel?.makeTime
                tv_like_count?.text = if (model?.searchRecipeModel?.favoriteCount ?: 0 <= 0) "收藏" else NumFormatUtil.likeNumFormat(model?.searchRecipeModel?.favoriteCount
                        ?: 0)
                tv_like_count?.setTypeface(TypefaceUtil.getTypeface(tv_like_count.getContext()))
//                helper?.setText(R.id.tv_count, NumFormatUtil.likeNumFormat(item.getLikeCount()))
                if (model?.searchRecipeModel?.favorite == true) {
                    tv_like_count?.setTextColor(ContextCompat.getColor(mContext, R.color.like_text_color))
                } else {
                    tv_like_count?.setTextColor(ContextCompat.getColor(mContext, R.color.c_c4c4c4))
                }

            }
            2 -> {
                view_type0?.visibility = View.GONE
                view_type2?.visibility = View.VISIBLE
                var str = ""
                if(!TextUtils.isEmpty(model?.name))
                {
                    str = if(model?.name?.length!!>9) "他们正在分享“"+model?.name.substring(0,9) +"...”" else "他们正在分享“"+model?.name +"”"
                }
                title2?.text = str
                for (i in 0 until model?.searchContentList.size) {
                    var url = model?.searchContentList?.get(i)?.smallPic
                    if (url==null||url.isEmpty()) {
                        url = model?.searchContentList?.get(i)?.coverImage
                    }
                    when(i){
                        0->{GlideUtils.load(url, iv_1)}
                        1->{GlideUtils.load(url, iv_2)}
                        2->{GlideUtils.load(url, iv_3)}
                    }

                }
            }
        }

        helper?.addOnClickListener(R.id.like)
    }
}