package com.gfeng.daydaycook.search.adapter

import android.widget.ImageView
import android.widget.TextView
import com.chad.library.adapter.base.BaseQuickAdapter
import com.chad.library.adapter.base.BaseViewHolder
import com.gfeng.daydaycook.R
import com.gfeng.daydaycook.search.entity.SearchUserModel
import com.gfeng.daydaycook.util.FocusImageSrcUtils
import com.gfeng.daydaycook.util.GlideUtils
import com.makeramen.roundedimageview.RoundedImageView

/**
 * Life Is Better With DayDayCook
 * author: HuangQiang
 * created on: 2019/4/18 15:44.
 * description:
 */
class SearchUserResultAdapter(layoutResId: Int) : BaseQuickAdapter<SearchUserModel.Data, BaseViewHolder>(layoutResId) {

    override fun convert(helper: BaseViewHolder, item: SearchUserModel.Data) {
        val mHeadImageView = helper.getView<RoundedImageView>(R.id.iv_headicon)
        val mNickName = helper.getView<TextView>(R.id.nickName_tv)
        val mFansCount = helper.getView<TextView>(R.id.fans_count)
        val iv_focus_status = helper.getView<ImageView>(R.id.iv_focus_status)
        GlideUtils.loadCircleCrop(item.userInfo.header, R.drawable.default_user, mHeadImageView)

        mNickName.text = item.userInfo.nickName
        mFansCount.text = item.userInfo.contentCount.toString() + "篇发布 " + item.userInfo.followerCount + "个粉丝"

        FocusImageSrcUtils.setImageSrc(item.watchSelf, item.watchUser, iv_focus_status, item.isSelf)
        helper.addOnClickListener(R.id.iv_focus_status)
//        iv_focus_status.setOnClickListener { v ->
//            if (AppMgr.login(v.context)) {
//                return@setOnClickListener
//            }
//            val isWatchUser = FocusImageSrcUtils.setFocusChange(item.watchSelf, item.watchUser, iv_focus_status, item.isSelf)
//            data[helper.adapterPosition].watchUser = isWatchUser
//        }
    }
}

